
#include <stdio.h>
#ifndef SOLARIS
#include <a.out.h>
#endif
#if defined(linux) || defined(SOLARIS)
#include <elf.h>
#endif

#ifndef SEEK_SET
#define SEEK_SET 0
#endif

/*
 * magic --
 *	check for file magic numbers.  This code would best be shared with
 *	the file(1) program or, perhaps, more should not try and be so smart?
 */
int
magic(FILE *f, char *fs)
{
#ifdef __hp9000s800
    unsigned long ex;
#   define N_BADMAG(x) (((x)!=EXEC_MAGIC)&&((x)!=SHARE_MAGIC))
#elif defined(SOLARIS)
    struct { unsigned long a_info; } ex;
#elif defined(mips) || defined(__osf__) || defined(_AIX)
    struct aouthdr ex;
#else
    struct exec ex;
#endif
    int bad;

    bad = 0;
    if (fread(&ex, sizeof(ex), 1, f) == 1) {
#ifdef N_BADMAG
	bad = ! N_BADMAG (ex);
#endif
#ifdef ELFMAG
	if (bad == 0) {
	    unsigned long elfmagic;
	    char *elfbytes = ELFMAG;
	    elfmagic = *((unsigned long *) elfbytes);
	    bad = (ex.a_info == elfmagic);
	}
#endif
#ifdef ISCOFF
	if (bad == 0) {
	    bad = ISCOFF (ex.magic);
	}
#endif
    }

    if (bad != 0) {
	printf("\n******** %s: Not a text file ********\n\n", fs);
	fclose(f);
	return(1);
    }
    fseek(f, 0L, SEEK_SET);		/* rewind() not necessary */
    return(0);
}
